﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System;
using System.Data.SQLite;
using System.Data.SQLite.EF6;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Load += Form_Load;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            string connectionString = "URI=file:test.db";

            using(SQLiteConnection connection = new SQLiteConnection(connectionString))
            {
                connection.Open();

                DataTable table = GetDataTable(connection, "SELECT * FROM Sample");

                this.dataGridView.DataSource = table;
            }        
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 비 쿼리 실행하기 - ExecuteNonQuery(connection, commandText)

        /// <summary>
        /// 비 쿼리 실행하기
        /// </summary>
        /// <param name="connection">연결</param>
        /// <param name="commandText">명령 텍스트</param>
        private void ExecuteNonQuery(SQLiteConnection connection, string commandText)
        {
            using(SQLiteCommand command = new SQLiteCommand(connection))
            {
                command.CommandText = commandText;

                command.ExecuteNonQuery();
            }
        }

        #endregion
        #region 데이터 테이블 구하기 - GetDataTable(connection, commandText)

        /// <summary>
        /// 데이터 테이블 구하기
        /// </summary>
        /// <param name="connection">연결</param>
        /// <param name="commandText">명령 텍스트</param>
        /// <returns>데이터 테이블</returns>
        private DataTable GetDataTable(SQLiteConnection connection, string commandText)
        {
            using(SQLiteDataAdapter adapter = new SQLiteDataAdapter(commandText, connection))
            {
                adapter.SelectCommand.CommandText = commandText;

                DataTable dataTable = new DataTable();

                adapter.Fill(dataTable);

                return dataTable;
            }
        }

        #endregion
    }
}
